<?php
///////////////////////////////////////////////////////////////////////////
define('HD_SERIAL_API_URL',   'http://www.hdserials.ru');

class Cursor
{

	    private $m_feed;
	    private $m_feed_url;
	    private $m_items_count;
        private $m_last_ref;

    ///////////////////////////////////////////////////////////////////////

    public function __construct($media_url)
    {
        if ($media_url === 'main_menu:fav')
            $this->m_feed_url = 'main_menu:fav';
        else
            HD::decode_user_data($media_url, $media_str, $this->m_feed_url);

        $this->m_items_count = 0;
        $this->m_feed = 0;
        $this->m_last_ref = "";
    }

    private function str_remove_spec($str)
    {
        $tmp = str_ireplace(chr(9), "", $str);
        $tmp = str_ireplace(chr(10), "", $tmp);
        $tmp = str_ireplace(chr(13), "", $tmp);
        
        return $tmp;
    }

    private function parse_subcategory()
    {
        hd_print("--> parse subcategory: started...");
        $subcategory = $this->m_feed_url;
        $ref = ($this->m_last_ref === "" ? $subcategory->subcategory_ref : $this->m_last_ref);
        $api = 'http://www.hdserials.ru';
        
        $items = array();

        hd_print("--->>> m_last_ref: $this->m_last_ref");
        
        $url = $api . $ref;
        
        $doc = HD::http_get_document($url);
        
        if ($this->m_feed > 0)
        {
            $tmp = explode("<!-- Pagination -->", $doc);
            if (count($tmp) < 2)
                return false;
                
            $page_nav = strstr($tmp[1], "<!-- End K2 Category Layout -->", true);
            $pages = explode('<li>&nbsp;<strong><a href="', $page_nav);
            $found = false;
            foreach ($pages as $page)
            {
                if (strstr($page, 'title="Следующая'))
                {
                    $ref = strstr($page, '"', true);
                    $found = true;
                    break;
                }
            }
            
            if ($found === false)
                return false;

            $url = $api . $ref;
            
            $doc = HD::http_get_document($url);
        }

        $this->m_last_ref = $ref;
        
        if (preg_match_all('/<div class="catItemImageBlock">[^<]*<span class="catItemImage">[^<]*<a href="([^"]*)" title="([^"]*)">[^<]*<img src="([^"]*)" alt="[^"]*"/i', $doc, $matches))
        {
            $nItems = count($matches[0]);
            for ($i = 0; $i < $nItems; $i++)
            {
                array_push
                (
                    $items,
                    HD::encode_user_data
                    (
                        array
                        (
                            'video_id' => $matches[1][$i],
                            'season_title' => $matches[2][$i],
                            'season_ref' => $matches[1][$i],
                            'season_image' => $api . $matches[3][$i]
                        )
                    )
                );
                ++$this->m_items_count;
            }
        }
/*        $videos = explode('<!-- Item title -->', $doc);
        unset($videos[0]);
        $videos = array_values($videos);

        foreach($videos as $video)
        {
            $tmp = explode('<a href="', $video);
            $season_ref = $this->str_remove_spec(strstr($tmp[1], '"', true));
            
            hd_print("--->>> season_ref: $season_ref");

            $tmp = explode('html">', $video);
            $season_title = $this->str_remove_spec(strstr($tmp[1], '</a>', true));

            hd_print("--->>> season_title: $season_title");
            
            $tmp = explode('<!-- Item Image -->', $video);
            $tmp = str_replace(chr(13), "", $tmp[1]);
            $tmp = str_replace(chr(10), "", $tmp);
            $tmp = explode('<img src="', $tmp);
            $season_image = strstr($tmp[1], '"', true);
            
            array_push
            (
                $items,
                HD::encode_user_data
                (
                    array
                    (
                        'video_id' => $season_ref,
                        'season_title' => $season_title,
                        'season_ref' => $season_ref,
                        'season_image' => $season_image
                    )
                )
            );
            ++$this->m_items_count;
        }
*/        
        return $items;
    }

    ///////////////////////////////////////////////////////////////////////
    private function parse_search_result($search)
    {
        hd_print("--> parse search result: started... $search");
        if ($this->m_feed > 0)
            return array();
            
        $ref = ($this->m_last_ref === "" ? $search : $this->m_last_ref);
        $api = ($this->m_last_ref === "" ? 'http://www.hdserials.ru/component/k2/itemlist/search.html?searchword=' : '');
        
        $items = array();

        $url = $api . $ref;
        
        $doc = HD::http_get_document($url);
        
        if (preg_match_all('/<div class="genericItemImageBlock">[^<]*<span class="genericItemImage">[^<]*<a href="([^"]*)" title="([^"]*)">[^<]*<img src="([^"]*)" alt="[^"]*"/i', $doc, $matches))
        {
            $nItems = count($matches[0]);
            for ($i = 0; $i < $nItems; $i++)
            {
                array_push
                (
                    $items,
                    HD::encode_user_data
                    (
                        array
                        (
                            'video_id' => $matches[1][$i],
                            'season_title' => $matches[2][$i],
                            'season_ref' => $matches[1][$i],
                            'season_image' => $api . $matches[3][$i]
                        )
                    )
                );
                ++$this->m_items_count;
            }
        }

/*        if ($this->m_feed > 0)
        {
            $tmp = explode('class="pagination"', $doc);
            if (count($tmp) < 2)
                return false;
                
            $page_nav = strstr($tmp[1], 'title="Последняя"', true);
            $pages = explode('<li>&nbsp;<strong><a href="', $page_nav);
            $found = false;
            foreach ($pages as $page)
            {
                if (strstr($page, 'title="Следующая'))
                {
                    $ref = strstr($page, '"', true);
                    $found = true;
                    break;
                }
            }
            
            if ($found === false)
                return false;

            $url = 'http://www.hdserials.ru' . $ref;
            
            $doc = HD::http_get_document($url);
        }

        $this->m_last_ref = $url;

        $tmp = explode('<ol class="list"', $doc);
        $list_block = strstr($tmp[1], '</ol>', true);

        $videos = explode('<li>', $list_block);
        unset($videos[0]);
        $videos = array_values($videos);

        foreach($videos as $video)
        {
            $tmp = explode('<a href="', $video);
            $season_ref = $this->str_remove_spec(strstr($tmp[1], '"', true));
            $season_ref = str_replace($api, '', $season_ref);
              
            $tmp = preg_split('/<a[^>]*>/i', $video);
            $season_title = $this->str_remove_spec(strstr($tmp[1], '</a>', true));
            
            array_push
            (
                $items,
                HD::encode_user_data
                (
                    array
                    (
                        'video_id' => $season_ref,
                        'season_title' => $season_title,
                        'season_ref' => $season_ref,
                    )
                )
            );
            ++$this->m_items_count;
        }
*/        
        return $items;
    }
    ///////////////////////////////////////////////////////////////////////

    private function get_next_fav(&$plugin_cookies)
    {
        hd_print("--> get favorites: started... $this->m_feed");
        
        $fav_items = isset($plugin_cookies->fav_items) ? $plugin_cookies->fav_items : '';
        
        $ref = "";
        
        $n = 0;
        foreach (ListUtil::string_to_list($fav_items) as $item)
        {
            if ($item == "")
                continue;
            
            if ($n == $this->m_feed)
            {
                $ref = $item;
            }

            ++$n;
            
        }

        if ($ref == "")
            return false;
        
        $items = array();

        $c = VideoCache::get($ref);
        if (!is_null($c))
        {
            array_push
            (
                $items,
                $c
            );

            ++$this->m_items_count;

            return $items;
            
        }

        $api = 'http://www.hdserials.ru';
        
        $url = $api . $ref;
        
        $doc = HD::http_get_document($url);

        // title
        $tmp = explode('<h2 class="itemTitle">', $doc);
        $season_title = $this->str_remove_spec(strstr($tmp[1], '</h2>', true));
        
        $is_has_new = true;

        if (isset($plugin_cookies->$ref))
        {
            $is_has_new = false;
            
            $videos = explode('<iframe src="', $doc);
            unset($videos[0]);
            $videos = array_values($videos);

            foreach($videos as $video)
            {
                $episode_ref = strstr($video, '"', true);
                $episode_ref = $this->str_remove_spec(str_ireplace("&amp;", "&", $episode_ref));
                
                hd_print("--->>> episode_ref: $episode_ref");

                if (isset($plugin_cookies->$ref))
                    if (!ListUtil::is_in_list($plugin_cookies->$ref, $episode_ref))
                        $is_has_new = true;
                            
                if ($is_has_new)
                    break;
            }
        }
        
        array_push
        (
            $items,
            HD::encode_user_data
            (
                array
                (
                    'video_id' => $ref,
                    'season_title' => $season_title,
                    'season_ref' => $ref,
                    'is_has_new' => $is_has_new
                )
            )
        );

        ++$this->m_items_count;

        return $items;
    }
    ///////////////////////////////////////////////////////////////////////

    public function next_chunk($plugin_cookies)
    {
	    hd_print("--> next_chunk(): started...");

        $api = HD_SERIAL_API_URL;
	    $items = array();
	    $from_fav = false;
	    $video_id = -1;

        if ($this->m_feed_url === 'main_menu:fav')
        {
            hd_print("--> parse favorites: started...");
            
            $items = $this->get_next_fav($plugin_cookies);
            ++$this->m_feed;

            if ($items === false)
                return false;
            
            return count($items) > 0 ? $items : false;
        }
	    if (HD::has_attribute($this->m_feed_url, 'ser_feed'))
	    {
		    hd_print("--> search: started...");
            
		    $search_text = $this->m_feed_url->ser_feed;
            
            $items = $this->parse_search_result($search_text);
            ++$this->m_feed;
            
		    hd_print("--> search for: " . $search_text);

            if ($items === false)
                return false;
                
            hd_print("--> next_chunk(): found " . count($items) . " items.");
            return count($items) > 0 ? $items : false;
	    }
	    else if (HD::has_attribute($this->m_feed_url, 'fav'))
        {
		    hd_print("--> parse favorites: started...");

		    if ($this->m_feed > 0)
			    return false;

		    $video_id = $this->m_feed_url->fav;

		    $url = $api . "/view/" . $video_id;
	    
		    $from_fav = true;
        }
        else if (HD::has_attribute($this->m_feed_url, 'subcategory_ref'))
        {
           $items = $this->parse_subcategory();
            ++$this->m_feed;

            if ($items === false)
                return false;
                
            hd_print("--> next_chunk(): found " . count($items) . " items.");
            return count($items) > 0 ? $items : false;
        }
	    else
	    {
		    return false;
	    }

	    if ($from_fav === false)
	    {
		    // download category video page
            try
            {
                $doc = HD::http_get_document($url);
            }
            catch(Exception $e)
            {
                hd_print("Connection error!!!");
                return false;
            }
	    
		    // get list of videos
	    	$videos = explode("<tr><td><a href='/view/", $doc);
		    unset($videos[0]);
		    $videos = array_values($videos);
	    }
	    else
	    {
		    $videos = array($url);
	    }
	

	    // iterate through videos
	    foreach($videos as $video)
	    {
		    if ($from_fav === false)
		    {
			    // get video page ref
			    $tmp = explode("'", $video);
			    $video_page_ref = '/view/' . $tmp[0];

			    // get video id
			    $tmp = explode("/view/", $video_page_ref);
			    $tmp = explode("?", $tmp[1]);
			    $video_id = $tmp[0];
			    $video_page_ref = $api . $video_page_ref;
		    }
		    else
		    {
			    $video_page_ref = $video;
		    }

		    // download category video page
            try
            {
                $page = HD::http_get_document($video_page_ref);
            }
            catch(Exception $e)
            {
                hd_print("Connection error!!!");
                return false;
            }

		    // get playlist
		    $tmp = explode("/playlist/", $page);		
		    if (count($tmp) < 2)	// nothing to play
			    continue;
		    $tmp = explode("'", $tmp[1]);
		    $playlist_url = $api . "/playlist/" . $tmp[0];

		    // get image
		    $video_image = "";
		    $tmp = explode('<link rel="image_src" href="http://www.ex.ua', $page);
		    if (count($tmp) > 1)
		    {
			    $tmp = explode('?', $tmp[1]);
			    $video_image = $tmp[0];
    //			hd_print("---> image mask $video_image");

			    // get real picture url
			    $tmp = explode($video_image, $page);
			    $tmp = explode("<img src='", $tmp[1]);
			    $video_image = $tmp[count($tmp) - 1] . $video_image;

			    $thumb_quality = (isset($plugin_cookies->thumb_quality) ? $plugin_cookies->thumb_quality : 'yes');
			    if ($thumb_quality === 'no')
			    {
			        $video_image .= '?100';
    //			    hd_print("--->>> Get small picture: $video_image");
			    }
			    else
			    {
			        $video_image .= '?800';
    //			    hd_print("--->>> Get big picture: $video_image");
			    }
		    }

		    // get video title
		    $video_title = "";
		    $tmp = explode('<meta name="title" content="', $page);
		    if (count($tmp) > 1)
		    {
			    $tmp = explode('"', $tmp[1]);
			    $video_title = $tmp[0];
		    }

            $is_has_new = false;
		    // get series count
		    $n_series = 0;
		    // download playlist
            try
            {
                $pl = HD::http_get_document($playlist_url);
            }
            catch(Exception $e)
            {
                hd_print("Connection error!!!");
                return false;
            }
		    $tmp = explode(chr(10), $pl);
		    foreach($tmp as $t)
		    {
			    if (strlen($t) == 0)
				    continue;
                if (!$is_has_new)
                    if (isset($plugin_cookies->$video_id))
                        if (!ListUtil::is_in_list($plugin_cookies->$video_id, $t))
                            $is_has_new = true;
			    ++$n_series;
		    }

            // get description block
            $descr_block = '';
            $tmp = explode("<a href='/user/", $page);
            if (count($tmp) > 1)
            {
    //            $tmp = explode("onclick='return play_online();'", $tmp[1]);
    //            if (count($tmp) > 1)
                 $descr_block = $tmp[1];
            }
            
            if (strlen($descr_block) > 0)
            {
                $descr_block = preg_replace("/(<b>|<\/b>|<font color='\S\S\S\S\S\S\S'>|<\/font>|<i>|<\/i>|<u>|<\/u>)/i", "", $descr_block);
    //            hd_print("--->>> Block: $descr_block");
                
                // get year
                $year = '';
                if (preg_match("/Год(.*)\d\d\d\d/i", $descr_block, $tmp))
                {
                    if (preg_match("/\d\d\d\d/", $tmp[0], $tmp))
                        $year = $tmp[0];
                }
                
                // genre
                $genre = '';
                if (preg_match("/Жанр:(.*)</i", $descr_block, $tmp))
                {
                    $tmp = strchr($tmp[0], ":");
                    $tmp = explode("<", $tmp);
                    $genre = ltrim($tmp[0], " :");
                }
                
                // get country
                $country = '';
                if (preg_match("/(Страна|Выпущено|Країна):(.*)</i", $descr_block, $tmp))
                {
                    $tmp = strchr($tmp[0], ":");
                    $tmp = explode("<", $tmp);
                    $country = ltrim($tmp[0], " :");
                }
                
                // director
                $director = '';
                if (preg_match("/(Режиссер|Режисер):(.*)</i", $descr_block, $tmp))
                {
                    $tmp = strchr($tmp[0], ":");
                    $tmp = explode("<", $tmp);
                    $director = ltrim($tmp[0], " :");
                }

                // get actors
                $actors = '';
                if (preg_match("/(В ролях|Актори):(.*)</i", $descr_block, $tmp))
                {
                    $tmp = strchr($tmp[0], ":");
                    $tmp = explode("<", $tmp);
                    $actors = ltrim($tmp[0], " :");
                }

                // get duration
                $duration = '';
                $duration_min = '';
                if (preg_match("/Продолжительность:(.*)</i", $descr_block, $tmp))
                {
    //                hd_print("--->>> $tmp[0]");
                    $tmp = strchr($tmp[0], ":");
                    $tmp = explode("<", $tmp);
                    $duration = ltrim($tmp[0], " :");
                    // XXX мин format
                    if (preg_match("/(\d*)(.*)мин/i", $duration, $tmp))
                    {
                        preg_match("/(\d*)/i", $tmp[0], $tmp);
                        $duration_min = $tmp[0];
                    }
                    // XX:XX:XX format
                    else if (preg_match("/\d\d:\d\d:\d\d/i", $duration, $tmp))
                    {
                        $tmp = $tmp[0];
                        $duration_min = ($tmp[0]*10+$tmp[1])*60+($tmp[3]*10+$tmp[4]);
                    }
                }

                // get description
                $description = '';
                if (preg_match("/(писание|фильме|южет(.*)|содержание):(.*)</i", $descr_block, $tmp))
                {
    //                hd_print("--->>> $tmp[0]");
                    $tmp = strchr($tmp[0], ":");
                    $tmp = preg_replace("/(<br>|<p>)/i", "", $tmp);
                    $tmp = explode("<", $tmp);
                    $description = ltrim($tmp[0], " :");
                }
            }

		    // TODO: get video params
		    // TODO: get audio tracks

		    // push video in to videos list
          array_push(
                $items,
		        HD::encode_user_data
		        (
                       	    array
			    (
				    'video_id' => $video_id,
				    'playlist_url' => $playlist_url,
				    'n_series' => $n_series,
				    'ndx_series' => -1,
				    'page_ref' => $video_page_ref,
				    'video_image_url' => $video_image,
				    'title' => $video_title,
				    'genre' => $genre,
				    'country' => $country,
				    'year' => $year,
				    'duration' => $duration,
                    'duration_min' => $duration_min,
				    'director' => $director,
				    'actors' => $actors,
				    'description' => $description,
    //				'video' => $vparams,
				    'from_fav' => $from_fav,
                    'is_has_new' => $is_has_new,
    //				'audio' => $audio_list
			    )
		        )
                    );
		    ++$this->m_items_count;
	    }
	    ++$this->m_feed;

	    hd_print("--> next_chunk(): found " . count($items) . " items.");
        return count($items) > 0 ? $items : false;
    }
}

///////////////////////////////////////////////////////////////////////////
?>
